// ---------------------------------------------------------------------------
// LoopConstraint.java
// Loop constraints in the LTL model checker.
// $Id: LoopConstraint.java,v 1.1 2022/08/24 12:47:14 schreine Exp $
//
// Author: Ágoston Sütő <agoston.suetoe@jku.at>
// Copyright (C) 2021-, Research Institute for Symbolic Computation (RISC)
// Johannes Kepler University, Linz, Austria, http://www.risc.jku.at
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// ----------------------------------------------------------------------------
package riscal.ltl.search;

import riscal.ltl.LTLChecker;

import java.util.ArrayList;
import java.util.List;

public interface LoopConstraint {
	boolean checkState(CheckingState state, LTLChecker ltlChecker);

	static List<LoopConstraint> createFinalStateConstraints(long finalSets) {
		ArrayList<LoopConstraint> constraints = new ArrayList<>();

		for (int i = 0; i < finalSets; i++) {
			int iCopy = i;
			constraints.add((state, ltlChecker) -> (state.automatonNode.finalStates & (1L << iCopy)) != 0);
		}

		return constraints;
	}
}
// ----------------------------------------------------------------------------
// end of file
// ----------------------------------------------------------------------------
